' MegaCrypt version 2B - WINDOWS Compiler version
' WARNING: do not decrypt version 1 files!
' CBC mode file encryption program
' Copyright Patterson Programming - 1996, 1997, 1998
' Contains registered material

'WARNING: This is an original work of authorship; however, patents might
'         or might not exist that apply to certain sections.
'         In addition, export from the U.S. of material of this
'         nature is restricted. The author disclaims any and all
'         liability arising from unauthorized use of this material.


DEFINT A-Z
CONST LeapFrogRounds% = 8
CONST BullFrogRounds% = 10

GLOBAL DrivePath$, filename$, fileSpec$, fileOFFSET&, method%, process%
GLOBAL verify%, Ppos%, password(31) AS BYTE, password2(31) AS BYTE

DIM SHARED initkey%(0 TO 31), k%(0 TO 23), LongKey%(0 TO 255)
DIM SHARED CurrentReadBuffer&, LastReadBuffer&, BufferPointer%
DIM SHARED keySUM%, DataLen&
DIM SHARED SmallFilesFound%, ReadOnlyFound%
DIM SHARED record(7) AS BYTE, ReadBuffer(1023) AS BYTE
DIM SHARED record2(15) AS BYTE, ReadBuffer2(2047) AS BYTE

DIM SHARED A1%(255), A2%(255), A3%(255), A4%(255)
DIM SHARED A5%(255), A6%(255), A7%(255), A8%(255)
DIM SHARED A9%(255), A10%(255), A11%(255), A12%(255)
DIM SHARED A13%(255), A14%(255), A15%(255), A16%(255)


SUB Main ()

    '* copyright notice
    form4.SHOW 1

    DrivePath$ = CURDIR$
    filename$ = "*.*"

    FOR i% = 0 TO 31: password(i%) = 32: NEXT
    Ppos% = 0

    '* main menu
    form1.SHOW

END SUB 'Main

SUB CleanUp ()

    ERASE A1%, A2%, A3%, A4%, A5%, A6%, A7%, A8%
    ERASE A9%, A10%, A11%, A12%, A13%, A14%, A15%, A16%
    FOR i% = 0 TO 31: password(i%) = 32: NEXT
    form1.CLS

END SUB

STATIC SUB DoProcess ()

    ON ERROR GOTO error_exit

    IF process% > 0 THEN

        SELECT CASE process%
            CASE 1
                BlockLen% = 8
                BufferLen% = 1024
                LeapFrogExpand
            CASE 2
                BlockLen% = 8
                BufferLen% = 1024
                LeapFrogExpand
            CASE 3
                BlockLen% = 16
                BufferLen% = 2048
                BullFrogExpand
            CASE 4
                BlockLen% = 16
                BufferLen% = 2048
                BullFrogExpand
                BullFrogInvert
        END SELECT

        IF RIGHT$(DrivePath$, 1) <> "\" THEN
            DrivePath$ = DrivePath$ + "\"
        END IF
        fileSpec$ = DIR$(DrivePath$ + filename$)

        IF (process% = previousProcess%) AND filesProcessed% > 0 THEN
            IF previousFile$ = DrivePath$ + filename$ THEN
                BEEP
                MSGBOX "File(s) Previously Processed!", 0, "Abort"
                GOTO Abort
            END IF
        END IF

        msgvalue% = MSGBOX(RIGHT$(DrivePath$ + filename$, 68), 260, _
        "Files To Process")
        IF msgvalue% <> 6 THEN
            GOTO Abort
        END IF

        '* show process status message
        form1.enabled = -1
        form1.mousepointer = 11
        form1.Status.visible = -1
        DOEVENTS
        form1.enabled = 0

        FoundSmallFiles% = 0
        filesProcessed% = 0
        ReadOnlyFound% = 0

        WHILE fileSpec$ <> ""

            OPEN DrivePath$ + fileSpec$ FOR BINARY ACCESS READ AS #1
            OPEN DrivePath$ + fileSpec$ FOR BINARY ACCESS WRITE AS #2
            IF ReadOnlyError% = 1 THEN
                ReadOnlyFound% = 1
                GOTO ReadOnlyExit
            END IF

            '* set length of data to process
            DataLen& = LOF(1) - fileOFFSET&
            CurrentReadBuffer& = 0
            LastReadBuffer& = (DataLen& - BlockLen%) \ BufferLen%
            BufferPointer% = 0

            '* file size must be >= to block size
            IF DataLen& < BlockLen% THEN
                FoundSmallFiles% = 1
            ELSE
                filesProcessed% = filesProcessed% + 1

                SELECT CASE process%
                    CASE 1
                        LeapFrogEncrypt
                    CASE 2
                        LeapFrogDecrypt
                    CASE 3
                        BullFrogEncrypt
                    CASE 4
                        BullFrogDecrypt
                END SELECT
            END IF

ReadOnlyExit:
            ReadOnlyError% = 0
            '* last block
            CLOSE
            fileSpec$ = DIR$

        WEND  'filesToProcess

        form1.Status.visible = 0
        form1.mousepointer = 0

        previousFile$ = DrivePath$ + filename$
        previousProcess% = process%

        IF FoundSmallFiles% > 0 THEN
            BEEP
            MSGBOX "Files Too Small To Process Skipped", 0, "Warning"
        END IF
        IF ReadOnlyFound% > 0 THEN
            BEEP
            MSGBOX "Read-Only Files Skipped", 0, "Warning"
        END IF

        MSGBOX "Files Processed: " + LTRIM$(STR$(filesProcessed%)), 0, _
        "Report"

Abort:
        process% = 0
        form1.enabled = -1

    END IF  'process > 0

    EXIT SUB 'DoProcess

error_exit:

IF ERR = 75 THEN
    ReadOnlyError% = 1
    RESUME NEXT

ELSE
    IF fileSpec$ <> "" THEN
        MSGBOX ERROR$ + " ==> " + fileSpec$, 0, "System Error"
    ELSE
        MSGBOX ERROR$, 0, "System Error"
    END IF

    CLOSE
    ERASE initkey%, k%, LongKey%
    FOR i% = 0 TO 31: password(i%) = 32: NEXT
    ERASE A1%, A2%, A3%, A4%, A5%, A6%, A7%, A8%
    ERASE A9%, A10%, A11%, A12%, A13%, A14%, A15%, A16%

    form1.CLS
    END
END IF

END SUB 'DoProcess


PRIVATE SUB LeapFrogEncrypt ()
DIM T1 AS INTEGER, T2 AS INTEGER, T3 AS INTEGER, T4 AS INTEGER

'* move file pointer if offset selected
    ByteNumber& = 1 + fileOFFSET&
    SEEK #1, ByteNumber&
    SEEK #2, ByteNumber&

ShortBlock% = DataLen& MOD 8
IF ShortBlock% = 0 THEN
    Blocks& = INT(DataLen& / 8)
ELSE
    Blocks& = INT(DataLen& / 8) + 1
END IF

FOR BlockNumber& = 1 TO Blocks&

'* check for EOF, adjust for short block
IF BlockNumber& = Blocks& THEN
    IF ShortBlock% <> 0 THEN
        ByteNumber& = ByteNumber& - (8 - ShortBlock%)
        SEEK #1, ByteNumber&
        SEEK #2, ByteNumber&
        FBR1% = 0
        FBR2% = 0
        FBR3% = 0
        FBR4% = 0
        FBR5% = 0
        FBR6% = 0
        FBR7% = 0
        FBR8% = 0
    END IF
END IF

GetNextRecord
p1% = record(0)
p2% = record(1)
p3% = record(2)
p4% = record(3)
p5% = record(4)
p6% = record(5)
p7% = record(6)
p8% = record(7)

p1% = p1% XOR FBR1%
p2% = p2% XOR FBR2%
p3% = p3% XOR FBR3%
p4% = p4% XOR FBR4%
p5% = p5% XOR FBR5%
p6% = p6% XOR FBR6%
p7% = p7% XOR FBR7%
p8% = p8% XOR FBR8%

'* mask the input data
p1% = p1% XOR A5%(A1%(keySUM%))
p2% = p2% XOR A6%(A2%(keySUM%))
p3% = p3% XOR A7%(A3%(keySUM%))
p4% = p4% XOR A8%(A4%(keySUM%))

p5% = p5% XOR A1%(A5%(keySUM%))
p6% = p6% XOR A2%(A6%(keySUM%))
p7% = p7% XOR A3%(A7%(keySUM%))
p8% = p8% XOR A4%(A8%(keySUM%))

FOR x% = 1 TO LeapFrogRounds%

    '* create temp variables
    T1 = A1%(p1%): T2 = A2%(p2%): T3 = A3%(p3%): T4 = A4%(p4%)

    '* note the T variable order
    p5% = p5% XOR A1%(A1%(T2 XOR T3) XOR T4)
    p6% = p6% XOR A2%(A2%(T1 XOR T4) XOR T3)
    p7% = p7% XOR A3%(A3%(T4 XOR T2) XOR T1)
    p8% = p8% XOR A4%(A4%(T3 XOR T1) XOR T2)
    p5% = (p5% + T1) AND &HFF
    p6% = (p6% + T2) AND &HFF
    p7% = (p7% + T3) AND &HFF
    p8% = (p8% + T4) AND &HFF

    '* do other half without swapping
    T1 = A5%(p5%): T2 = A6%(p6%): T3 = A7%(p7%): T4 = A8%(p8%)

    p1% = p1% XOR A5%(A5%(T2 XOR T3) XOR T4)
    p2% = p2% XOR A6%(A6%(T1 XOR T4) XOR T3)
    p3% = p3% XOR A7%(A7%(T4 XOR T2) XOR T1)
    p4% = p4% XOR A8%(A8%(T3 XOR T1) XOR T2)
    p1% = (p1% + T1) AND &HFF
    p2% = (p2% + T2) AND &HFF
    p3% = (p3% + T3) AND &HFF
    p4% = (p4% + T4) AND &HFF

NEXT

'* mask the output data
p1% = p1% XOR A5%(A1%((NOT keySUM%) AND &HFF))
p2% = p2% XOR A6%(A2%((NOT keySUM%) AND &HFF))
p3% = p3% XOR A7%(A3%((NOT keySUM%) AND &HFF))
p4% = p4% XOR A8%(A4%((NOT keySUM%) AND &HFF))

p5% = p5% XOR A1%(A5%((NOT keySUM%) AND &HFF))
p6% = p6% XOR A2%(A6%((NOT keySUM%) AND &HFF))
p7% = p7% XOR A3%(A7%((NOT keySUM%) AND &HFF))
p8% = p8% XOR A4%(A8%((NOT keySUM%) AND &HFF))

'* write cipher text
record(0) =p1%
record(1) =p2%
record(2) =p3%
record(3) =p4%
record(4) =p5%
record(5) =p6%
record(6) =p7%
record(7) =p8%
PutNextRecord
ByteNumber& = ByteNumber& + 8

FBR1% = p1%
FBR2% = p2%
FBR3% = p3%
FBR4% = p4%
FBR5% = p5%
FBR6% = p6%
FBR7% = p7%
FBR8% = p8%

NEXT

Form1.Enabled = -1

END SUB

PRIVATE SUB LeapFrogDecrypt ()
DIM T1 AS INTEGER, T2 AS INTEGER, T3 AS INTEGER, T4 AS INTEGER

'* move file pointer if offset selected
    ByteNumber& = 1 + fileOFFSET&
    SEEK #1, ByteNumber&
    SEEK #2, ByteNumber&

ShortBlock% = DataLen& MOD 8
IF ShortBlock% = 0 THEN
    Blocks& = INT(DataLen& / 8)
ELSE
    Blocks& = INT(DataLen& / 8) + 1
END IF

FOR BlockNumber& = 1 TO Blocks&

'* check for EOF, adjust for short block
IF BlockNumber& >= Blocks& - 1 THEN
    IF (BlockNumber& = Blocks& - 1) AND (ShortBlock% <> 0) THEN
        ByteNumber& = ByteNumber& + ShortBlock%
        SEEK #1, ByteNumber&
        SEEK #2, ByteNumber&
        HoldFBR1% = Pre_FBR1%
        HoldFBR2% = Pre_FBR2%
        HoldFBR3% = Pre_FBR3%
        HoldFBR4% = Pre_FBR4%
        HoldFBR5% = Pre_FBR5%
        HoldFBR6% = Pre_FBR6%
        HoldFBR7% = Pre_FBR7%
        HoldFBR8% = Pre_FBR8%
        Pre_FBR1% = 0
        Pre_FBR2% = 0
        Pre_FBR3% = 0
        Pre_FBR4% = 0
        Pre_FBR5% = 0
        Pre_FBR6% = 0
        Pre_FBR7% = 0
        Pre_FBR8% = 0
    END IF
    IF (BlockNumber& = Blocks&) AND (ShortBlock% <> 0) THEN
        ByteNumber& = ByteNumber& - (8 + ShortBlock%)
        SEEK #1, ByteNumber&
        SEEK #2, ByteNumber&
        Pre_FBR1% = HoldFBR1%
        Pre_FBR2% = HoldFBR2%
        Pre_FBR3% = HoldFBR3%
        Pre_FBR4% = HoldFBR4%
        Pre_FBR5% = HoldFBR5%
        Pre_FBR6% = HoldFBR6%
        Pre_FBR7% = HoldFBR7%
        Pre_FBR8% = HoldFBR8%
    END IF
END IF

GetNextRecord
p1% = record(0)
p2% = record(1)
p3% = record(2)
p4% = record(3)
p5% = record(4)
p6% = record(5)
p7% = record(6)
p8% = record(7)

FBR1% = p1%
FBR2% = p2%
FBR3% = p3%
FBR4% = p4%
FBR5% = p5%
FBR6% = p6%
FBR7% = p7%
FBR8% = p8%

'* unmask the input data
p1% = p1% XOR A5%(A1%((NOT keySUM%) AND &HFF))
p2% = p2% XOR A6%(A2%((NOT keySUM%) AND &HFF))
p3% = p3% XOR A7%(A3%((NOT keySUM%) AND &HFF))
p4% = p4% XOR A8%(A4%((NOT keySUM%) AND &HFF))

p5% = p5% XOR A1%(A5%((NOT keySUM%) AND &HFF))
p6% = p6% XOR A2%(A6%((NOT keySUM%) AND &HFF))
p7% = p7% XOR A3%(A7%((NOT keySUM%) AND &HFF))
p8% = p8% XOR A4%(A8%((NOT keySUM%) AND &HFF))

FOR x% = 1 TO LeapFrogRounds%

    '* create temp variables
    T1 = A5%(p5%): T2 = A6%(p6%): T3 = A7%(p7%): T4 = A8%(p8%)

    p1% = (p1% - T1) AND &HFF
    p2% = (p2% - T2) AND &HFF
    p3% = (p3% - T3) AND &HFF
    p4% = (p4% - T4) AND &HFF
    p1% = p1% XOR A5%(A5%(T2 XOR T3) XOR T4)
    p2% = p2% XOR A6%(A6%(T1 XOR T4) XOR T3)
    p3% = p3% XOR A7%(A7%(T4 XOR T2) XOR T1)
    p4% = p4% XOR A8%(A8%(T3 XOR T1) XOR T2)

    '* do other half without swapping
    T1 = A1%(p1%): T2 = A2%(p2%): T3 = A3%(p3%): T4 = A4%(p4%)

    p5% = (p5% - T1) AND &HFF
    p6% = (p6% - T2) AND &HFF
    p7% = (p7% - T3) AND &HFF
    p8% = (p8% - T4) AND &HFF
    p5% = p5% XOR A1%(A1%(T2 XOR T3) XOR T4)
    p6% = p6% XOR A2%(A2%(T1 XOR T4) XOR T3)
    p7% = p7% XOR A3%(A3%(T4 XOR T2) XOR T1)
    p8% = p8% XOR A4%(A4%(T3 XOR T1) XOR T2)

NEXT

'* unmask the output data
p1% = p1% XOR A5%(A1%(keySUM%))
p2% = p2% XOR A6%(A2%(keySUM%))
p3% = p3% XOR A7%(A3%(keySUM%))
p4% = p4% XOR A8%(A4%(keySUM%))

p5% = p5% XOR A1%(A5%(keySUM%))
p6% = p6% XOR A2%(A6%(keySUM%))
p7% = p7% XOR A3%(A7%(keySUM%))
p8% = p8% XOR A4%(A8%(keySUM%))

p1% = p1% XOR Pre_FBR1%
p2% = p2% XOR Pre_FBR2%
p3% = p3% XOR Pre_FBR3%
p4% = p4% XOR Pre_FBR4%
p5% = p5% XOR Pre_FBR5%
p6% = p6% XOR Pre_FBR6%
p7% = p7% XOR Pre_FBR7%
p8% = p8% XOR Pre_FBR8%
Pre_FBR1% = FBR1%
Pre_FBR2% = FBR2%
Pre_FBR3% = FBR3%
Pre_FBR4% = FBR4%
Pre_FBR5% = FBR5%
Pre_FBR6% = FBR6%
Pre_FBR7% = FBR7%
Pre_FBR8% = FBR8%

'* write plain text
record(0) =p1%
record(1) =p2%
record(2) =p3%
record(3) =p4%
record(4) =p5%
record(5) =p6%
record(6) =p7%
record(7) =p8%
PutNextRecord
ByteNumber& = ByteNumber& + 8

NEXT

Form1.Enabled = -1

END SUB

STATIC SUB GetNextRecord ()

'* if data less than buffer size read each record
'* no need to adjust for shortblock here
IF CurrentReadBuffer& = LastReadBuffer& THEN
    GET #1, , record
ELSE
    IF BufferPointer% = 0 THEN
        GET #1, , ReadBuffer
    END IF

    '* move 8 bytes
    FOR x% = 0 TO 7
        record(x%) = ReadBuffer(x% + BufferPointer%)
    NEXT
END IF
END SUB

STATIC SUB PutNextRecord ()

'* set buffer size to 1K
IF CurrentReadBuffer& = LastReadBuffer& THEN
    PUT #2, , record
ELSE
    '* move 8 bytes
    FOR x% = 0 TO 7
        ReadBuffer(x% + BufferPointer%) = record(x%)
    NEXT

    IF BufferPointer% = 1016 THEN
        PUT #2, , ReadBuffer
        CurrentReadBuffer& = CurrentReadBuffer& + 1
        BufferPointer% = 0
    ELSE
        BufferPointer% = BufferPointer% + 8
    END IF
END IF
END SUB

PRIVATE SUB LeapFrogExpand ()

PackPassword
FOR i% = 0 TO 23
    IF k%(23 - i%) <> 0 THEN EXIT FOR
NEXT
RealKeyLen% = 24 - i%

'* replicate key into array
y% = 0
FOR x% = 0 TO 255
    LongKey%(x%) = k%(y%)
    y% = (y% + 1) MOD RealKeyLen%
NEXT

keySUM% = 0
'* get checksum of real key
FOR i% = 0 TO 15
    keySUM% = (keySUM% + k%(i%)) AND &HFF
NEXT

'* initialize expanded key arrays
FOR i% = 0 TO 255
    A1%(i%) = i%: A5%(i%) = i%
    A2%(i%) = i%: A6%(i%) = i%
    A3%(i%) = i%: A7%(i%) = i%
    A4%(i%) = i%: A8%(i%) = i%
NEXT

j% = 0
'* randomize array
FOR i% = 0 TO 255
    j% = (j% + A1%(i%) + LongKey%(i%)) AND &HFF
    SWAP A1%(i%), A1%(j%)
NEXT
FOR i% = 0 TO 255: j% = (j% + A1%(i%)) AND &HFF: SWAP A1%(i%), A1%(j%): NEXT

'* randomize the other arrays
FOR i% = 0 TO 255
    j% = (j% + A1%(A2%(i%)) + A1%(LongKey%(i%))) AND &HFF
    SWAP A2%(i%), A2%(j%)
NEXT
FOR i% = 0 TO 255
    j% = (j% + A2%(A3%(i%)) + A2%(LongKey%(i%))) AND &HFF
    SWAP A3%(i%), A3%(j%)
NEXT
FOR i% = 0 TO 255
    j% = (j% + A3%(A4%(i%)) + A3%(LongKey%(i%))) AND &HFF
    SWAP A4%(i%), A4%(j%)
NEXT

FOR i% = 0 TO 255
    j% = (j% + A4%(A5%(i%)) + A4%(LongKey%(i%))) AND &HFF
    SWAP A5%(i%), A5%(j%)
NEXT
FOR i% = 0 TO 255
    j% = (j% + A5%(A6%(i%)) + A5%(LongKey%(i%))) AND &HFF
    SWAP A6%(i%), A6%(j%)
NEXT
FOR i% = 0 TO 255
    j% = (j% + A6%(A7%(i%)) + A6%(LongKey%(i%))) AND &HFF
    SWAP A7%(i%), A7%(j%)
NEXT
FOR i% = 0 TO 255
    j% = (j% + A7%(A8%(i%)) + A7%(LongKey%(i%))) AND &HFF
    SWAP A8%(i%), A8%(j%)
NEXT

'* erase initial key arrays
ERASE initkey%, k%, LongKey%

END SUB

PRIVATE SUB BullFrogEncrypt ()
DIM FBR(15) AS BYTE
DIM char(15) AS BYTE

'* move file pointer if offset selected
    ByteNumber& = 1 + fileOFFSET&
    SEEK #1, ByteNumber&
    SEEK #2, ByteNumber&

ShortBlock% = DataLen& MOD 16
IF ShortBlock% = 0 THEN
    Blocks& = INT(DataLen& / 16)
ELSE
    Blocks& = INT(DataLen& / 16) + 1
END IF

FOR BlockNumber& = 1 TO Blocks&

'* check for EOF, adjust for short block
IF BlockNumber& = Blocks& THEN
    IF ShortBlock% <> 0 THEN
        ByteNumber& = ByteNumber& - (16 - ShortBlock%)
        SEEK #1, ByteNumber&
        SEEK #2, ByteNumber&
        ERASE FBR
    END IF
END IF

GetNextRecord2

FOR i% = 0 TO 15
    char(i%) = record2(i%) XOR FBR(i%)
NEXT

FOR r% = 1 TO BullFrogRounds%

'* encrypt segments *
offset% = 0
FOR s% = 0 TO 3

    A% = char(offset%)
    B% = char(offset% + 1)
    C% = char(offset% + 2)
    D% = char(offset% + 3)

    SELECT CASE s%
    CASE 0
        A% = A1%(A%): B% = A2%(B%): C% = A3%(C%): D% = A4%(D%)
    CASE 1
        A% = A5%(A%): B% = A6%(B%): C% = A7%(C%): D% = A8%(D%)
    CASE 2
        A% = A9%(A%): B% = A10%(B%): C% = A11%(C%): D% = A12%(D%)
    CASE 3
        A% = A13%(A%): B% = A14%(B%): C% = A15%(C%): D% = A16%(D%)
    END SELECT

    A% = A% XOR (B% OR (NOT (C% XOR D%)))
    B% = B% XOR (C% OR (NOT (D% XOR A%)))
    C% = C% XOR (D% OR (NOT (A% XOR B%)))
    D% = D% XOR (A% OR (NOT (B% XOR C%)))

    char(offset%) = A% AND &HFF
    char(offset% + 1) = B% AND &HFF
    char(offset% + 2) = C% AND &HFF
    char(offset% + 3) = D% AND &HFF

    offset% = offset% + 4

NEXT

'* encrypt block *
FOR offset% = 0 TO 3

    A% = char(offset%)
    B% = char(offset% + 4)
    C% = char(offset% + 8)
    D% = char(offset% + 12)

    A% = A% XOR (B% OR (NOT (C% XOR D%)))
    B% = B% XOR (C% OR (NOT (D% XOR A%)))
    C% = C% XOR (D% OR (NOT (A% XOR B%)))
    D% = D% XOR (A% OR (NOT (B% XOR C%)))

    char(offset%) = A% AND &HFF
    char(offset% + 4) = B% AND &HFF
    char(offset% + 8) = C% AND &HFF
    char(offset% + 12) = D% AND &HFF

NEXT

NEXT

'* output function *
offset% = 0
FOR s% = 0 TO 3

    A% = char(offset%)
    B% = char(offset% + 1)
    C% = char(offset% + 2)
    D% = char(offset% + 3)

    SELECT CASE s%
    CASE 0
        A% = A1%(A%): B% = A2%(B%): C% = A3%(C%): D% = A4%(D%)
    CASE 1
        A% = A5%(A%): B% = A6%(B%): C% = A7%(C%): D% = A8%(D%)
    CASE 2
        A% = A9%(A%): B% = A10%(B%): C% = A11%(C%): D% = A12%(D%)
    CASE 3
        A% = A13%(A%): B% = A14%(B%): C% = A15%(C%): D% = A16%(D%)
    END SELECT

    char(offset%) = A% AND &HFF
    char(offset% + 1) = B% AND &HFF
    char(offset% + 2) = C% AND &HFF
    char(offset% + 3) = D% AND &HFF

    offset% = offset% + 4

NEXT

FOR i% = 0 TO 15
    record2(i%) = char(i%)
NEXT

PutNextRecord2
ByteNumber& = ByteNumber& + 16

FOR i% = 0 TO 15
    FBR(i%) = record2(i%)
NEXT

NEXT

Form1.Enabled = -1

END SUB

PRIVATE SUB BullFrogDecrypt ()
DIM FBR(15) AS BYTE, char(15) AS BYTE
DIM HoldFBR(15) AS BYTE, Pre_FBR(15) AS BYTE

'* move file pointer if offset selected
    ByteNumber& = 1 + fileOFFSET&
    SEEK #1, ByteNumber&
    SEEK #2, ByteNumber&

ShortBlock% = DataLen& MOD 16
IF ShortBlock% = 0 THEN
    Blocks& = INT(DataLen& / 16)
ELSE
    Blocks& = INT(DataLen& / 16) + 1
END IF

FOR BlockNumber& = 1 TO Blocks&

'* check for EOF, adjust for short block
IF BlockNumber& >= Blocks& - 1 THEN
    IF (BlockNumber& = Blocks& - 1) AND (ShortBlock% <> 0) THEN
        ByteNumber& = ByteNumber& + ShortBlock%
        SEEK #1, ByteNumber&
        SEEK #2, ByteNumber&
        FOR i% = 0 to 15: HoldFBR(i%) = Pre_FBR(i%): NEXT
        ERASE Pre_FBR
    END IF
    IF (BlockNumber& = Blocks&) AND (ShortBlock% <> 0) THEN
        ByteNumber& = ByteNumber& - (16 + ShortBlock%)
        SEEK #1, ByteNumber&
        SEEK #2, ByteNumber&
        FOR i% = 0 to 15: Pre_FBR(i%) = HoldFBR(i%): NEXT
    END IF
END IF

GetNextRecord2

FOR i% = 0 TO 15
    FBR(i%) = record2(i%)
    char(i%) = record2(i%)
NEXT

'* reverse output function *
offset% = 0
FOR s% = 0 TO 3

    A% = char(offset%)
    B% = char(offset% + 1)
    C% = char(offset% + 2)
    D% = char(offset% + 3)

    SELECT CASE s%
    CASE 0
        A% = A1%(A%): B% = A2%(B%): C% = A3%(C%): D% = A4%(D%)
    CASE 1
        A% = A5%(A%): B% = A6%(B%): C% = A7%(C%): D% = A8%(D%)
    CASE 2
        A% = A9%(A%): B% = A10%(B%): C% = A11%(C%): D% = A12%(D%)
    CASE 3
        A% = A13%(A%): B% = A14%(B%): C% = A15%(C%): D% = A16%(D%)
    END SELECT

    char(offset%) = A% AND &HFF
    char(offset% + 1) = B% AND &HFF
    char(offset% + 2) = C% AND &HFF
    char(offset% + 3) = D% AND &HFF

    offset% = offset% + 4

NEXT

FOR r% = 1 TO BullFrogRounds%

'* decrypt block *
FOR offset% = 0 TO 3

    A% = char(offset%)
    B% = char(offset% + 4)
    C% = char(offset% + 8)
    D% = char(offset% + 12)

    D% = D% XOR (A% OR (NOT (B% XOR C%)))
    C% = C% XOR (D% OR (NOT (A% XOR B%)))
    B% = B% XOR (C% OR (NOT (D% XOR A%)))
    A% = A% XOR (B% OR (NOT (C% XOR D%)))

    char(offset%) = A% AND &HFF
    char(offset% + 4) = B% AND &HFF
    char(offset% + 8) = C% AND &HFF
    char(offset% + 12) = D% AND &HFF

NEXT

'* decrypt segments *
offset% = 0
FOR s% = 0 TO 3

    A% = char(offset%)
    B% = char(offset% + 1)
    C% = char(offset% + 2)
    D% = char(offset% + 3)

    D% = D% XOR (A% OR ((NOT (B% XOR C%)) AND &HFF))
    C% = C% XOR (D% OR ((NOT (A% XOR B%)) AND &HFF))
    B% = B% XOR (C% OR ((NOT (D% XOR A%)) AND &HFF))
    A% = A% XOR (B% OR ((NOT (C% XOR D%)) AND &HFF))

    SELECT CASE s%
    CASE 0
        A% = A1%(A%): B% = A2%(B%): C% = A3%(C%): D% = A4%(D%)
    CASE 1
        A% = A5%(A%): B% = A6%(B%): C% = A7%(C%): D% = A8%(D%)
    CASE 2
        A% = A9%(A%): B% = A10%(B%): C% = A11%(C%): D% = A12%(D%)
    CASE 3
        A% = A13%(A%): B% = A14%(B%): C% = A15%(C%): D% = A16%(D%)
    END SELECT

    char(offset%) = A% AND &HFF
    char(offset% + 1) = B% AND &HFF
    char(offset% + 2) = C% AND &HFF
    char(offset% + 3) = D% AND &HFF

    offset% = offset% + 4

NEXT

NEXT

FOR i% = 0 TO 15
    record2(i%) = char(i%) XOR Pre_FBR(i%)
NEXT

FOR i% = 0 TO 15
    Pre_FBR(i%) = FBR(i%)
NEXT

PutNextRecord2
ByteNumber& = ByteNumber& + 16

NEXT

Form1.Enabled = -1

END SUB

STATIC SUB GetNextRecord2 ()

'* if data less than buffer size read each record
'* no need to adjust for shortblock here
IF CurrentReadBuffer& = LastReadBuffer& THEN
    GET #1, , record2
ELSE
    IF BufferPointer% = 0 THEN
        GET #1, , ReadBuffer2
    END IF
    '* move 16 bytes
    FOR x% = 0 TO 15
        record2(x%) = ReadBuffer2(x% + BufferPointer%)
    NEXT
END IF
END SUB

STATIC SUB PutNextRecord2 ()

'* set buffer size to 2K
IF CurrentReadBuffer& = LastReadBuffer& THEN
    PUT #2, , record2
ELSE
    '* move 16 bytes
    FOR x% = 0 TO 15
        ReadBuffer2(x% + BufferPointer%) = record2(x%)
    NEXT

    IF BufferPointer% = 2032 THEN
        PUT #2, , ReadBuffer2
        CurrentReadBuffer& = CurrentReadBuffer& + 1
        BufferPointer% = 0
    ELSE
        BufferPointer% = BufferPointer% + 16
    END IF
END IF
END SUB

PRIVATE SUB BullFrogExpand ()

PackPassword
FOR i% = 0 TO 23
    IF k%(23 - i%) <> 0 THEN EXIT FOR
NEXT
RealKeyLen% = 24 - i%

'* replicate key into array
y% = 0
FOR x% = 0 TO 255
    LongKey%(x%) = k%(y%)
    y% = (y% + 1) MOD RealKeyLen%
NEXT

'* initialize expanded key arrays
FOR i% = 0 TO 255
    A1%(i%) = i%: A2%(i%) = i%: A3%(i%) = i%: A4%(i%) = i%
    A5%(i%) = i%: A6%(i%) = i%: A7%(i%) = i%: A8%(i%) = i%
    A9%(i%) = i%: A10%(i%) = i%: A11%(i%) = i%: A12%(i%) = i%
    A13%(i%) = i%: A14%(i%) = i%: A15%(i%) = i%: A16%(i%) = i%
NEXT

j% = 0
'* randomize array
FOR i% = 0 TO 255
    j% = (j% + A1%(i%) + LongKey%(i%)) AND &HFF
    SWAP A1%(i%), A1%(j%)
NEXT
FOR i% = 0 TO 255: j% = (j% + A1%(i%)) AND &HFF: SWAP A1%(i%), A1%(j%): NEXT

'* randomize the other arrays
FOR i% = 0 TO 255
    j% = (j% + A1%(A2%(i%)) + A1%(LongKey%(i%))) AND &HFF
    SWAP A2%(i%), A2%(j%)
NEXT
FOR i% = 0 TO 255
    j% = (j% + A2%(A3%(i%)) + A2%(LongKey%(i%))) AND &HFF
    SWAP A3%(i%), A3%(j%)
NEXT
FOR i% = 0 TO 255
    j% = (j% + A3%(A4%(i%)) + A3%(LongKey%(i%))) AND &HFF
    SWAP A4%(i%), A4%(j%)
NEXT

FOR i% = 0 TO 255
    j% = (j% + A4%(A5%(i%)) + A4%(LongKey%(i%))) AND &HFF
    SWAP A5%(i%), A5%(j%)
NEXT
FOR i% = 0 TO 255
    j% = (j% + A5%(A6%(i%)) + A5%(LongKey%(i%))) AND &HFF
    SWAP A6%(i%), A6%(j%)
NEXT
FOR i% = 0 TO 255
    j% = (j% + A6%(A7%(i%)) + A6%(LongKey%(i%))) AND &HFF
    SWAP A7%(i%), A7%(j%)
NEXT
FOR i% = 0 TO 255
    j% = (j% + A7%(A8%(i%)) + A7%(LongKey%(i%))) AND &HFF
    SWAP A8%(i%), A8%(j%)
NEXT

FOR i% = 0 TO 255
    j% = (j% + A8%(A9%(i%)) + A8%(LongKey%(i%))) AND &HFF
    SWAP A9%(i%), A9%(j%)
NEXT
FOR i% = 0 TO 255
    j% = (j% + A9%(A10%(i%)) + A9%(LongKey%(i%))) AND &HFF
    SWAP A10%(i%), A10%(j%)
NEXT
FOR i% = 0 TO 255
    j% = (j% + A10%(A11%(i%)) + A10%(LongKey%(i%))) AND &HFF
    SWAP A11%(i%), A11%(j%)
NEXT
FOR i% = 0 TO 255
    j% = (j% + A11%(A12%(i%)) + A11%(LongKey%(i%))) AND &HFF
    SWAP A12%(i%), A12%(j%)
NEXT

FOR i% = 0 TO 255
    j% = (j% + A12%(A13%(i%)) + A12%(LongKey%(i%))) AND &HFF
    SWAP A13%(i%), A13%(j%)
NEXT
FOR i% = 0 TO 255
    j% = (j% + A13%(A14%(i%)) + A13%(LongKey%(i%))) AND &HFF
    SWAP A14%(i%), A14%(j%)
NEXT
FOR i% = 0 TO 255
    j% = (j% + A14%(A15%(i%)) + A14%(LongKey%(i%))) AND &HFF
    SWAP A15%(i%), A15%(j%)
NEXT
FOR i% = 0 TO 255
    j% = (j% + A15%(A16%(i%)) + A15%(LongKey%(i%))) AND &HFF
    SWAP A16%(i%), A16%(j%)
NEXT

'* erase initial key arrays
ERASE initkey%, k%, LongKey%

END SUB

PRIVATE SUB BullFrogInvert ()
DIM SortArray%(255)

FOR i% = 0 TO 255: SortArray%(A1%(i%)) = i%: NEXT
FOR i% = 0 TO 255: A1%(i%) = SortArray%(i%): NEXT

FOR i% = 0 TO 255: SortArray%(A2%(i%)) = i%: NEXT
FOR i% = 0 TO 255: A2%(i%) = SortArray%(i%): NEXT

FOR i% = 0 TO 255: SortArray%(A3%(i%)) = i%: NEXT
FOR i% = 0 TO 255: A3%(i%) = SortArray%(i%): NEXT

FOR i% = 0 TO 255: SortArray%(A4%(i%)) = i%: NEXT
FOR i% = 0 TO 255: A4%(i%) = SortArray%(i%): NEXT

FOR i% = 0 TO 255: SortArray%(A5%(i%)) = i%: NEXT
FOR i% = 0 TO 255: A5%(i%) = SortArray%(i%): NEXT

FOR i% = 0 TO 255: SortArray%(A6%(i%)) = i%: NEXT
FOR i% = 0 TO 255: A6%(i%) = SortArray%(i%): NEXT

FOR i% = 0 TO 255: SortArray%(A7%(i%)) = i%: NEXT
FOR i% = 0 TO 255: A7%(i%) = SortArray%(i%): NEXT

FOR i% = 0 TO 255: SortArray%(A8%(i%)) = i%: NEXT
FOR i% = 0 TO 255: A8%(i%) = SortArray%(i%): NEXT

FOR i% = 0 TO 255: SortArray%(A9%(i%)) = i%: NEXT
FOR i% = 0 TO 255: A9%(i%) = SortArray%(i%): NEXT

FOR i% = 0 TO 255: SortArray%(A10%(i%)) = i%: NEXT
FOR i% = 0 TO 255: A10%(i%) = SortArray%(i%): NEXT

FOR i% = 0 TO 255: SortArray%(A11%(i%)) = i%: NEXT
FOR i% = 0 TO 255: A11%(i%) = SortArray%(i%): NEXT

FOR i% = 0 TO 255: SortArray%(A12%(i%)) = i%: NEXT
FOR i% = 0 TO 255: A12%(i%) = SortArray%(i%): NEXT

FOR i% = 0 TO 255: SortArray%(A13%(i%)) = i%: NEXT
FOR i% = 0 TO 255: A13%(i%) = SortArray%(i%): NEXT

FOR i% = 0 TO 255: SortArray%(A14%(i%)) = i%: NEXT
FOR i% = 0 TO 255: A14%(i%) = SortArray%(i%): NEXT

FOR i% = 0 TO 255: SortArray%(A15%(i%)) = i%: NEXT
FOR i% = 0 TO 255: A15%(i%) = SortArray%(i%): NEXT

FOR i% = 0 TO 255: SortArray%(A16%(i%)) = i%: NEXT
FOR i% = 0 TO 255: A16%(i%) = SortArray%(i%): NEXT

END SUB

PRIVATE SUB PackPassword ()

FOR i% = 0 TO 31
    initkey%(i%) = password(i%) - 32
NEXT

'* pack 32 ASCII character password into real 192-bit key (24 bytes)
k%(0) = initkey%(0) OR ((initkey%(1) AND &H3) * 64)
k%(1) = ((initkey%(1) AND &H3C) \ 4) OR ((initkey%(2) AND &HF) * 16)
k%(2) = ((initkey%(2) AND &H30) \ 16) OR (initkey%(3) * 4)
k%(3) = initkey%(4) OR ((initkey%(5) AND &H3) * 64)
k%(4) = ((initkey%(5) AND &H3C) \ 4) OR ((initkey%(6) AND &HF) * 16)
k%(5) = ((initkey%(6) AND &H30) \ 16) OR (initkey%(7) * 4)
k%(6) = initkey%(8) OR ((initkey%(9) AND &H3) * 64)
k%(7) = ((initkey%(9) AND &H3C) \ 4) OR ((initkey%(10) AND &HF) * 16)
k%(8) = ((initkey%(10) AND &H30) \ 16) OR (initkey%(11) * 4)
k%(9) = initkey%(12) OR ((initkey%(13) AND &H3) * 64)
k%(10) = ((initkey%(13) AND &H3C) \ 4) OR ((initkey%(14) AND &HF) * 16)
k%(11) = ((initkey%(14) AND &H30) \ 16) OR (initkey%(15) * 4)
k%(12) = initkey%(16) OR ((initkey%(17) AND &H3) * 64)
k%(13) = ((initkey%(17) AND &H3C) \ 4) OR ((initkey%(18) AND &HF) * 16)
k%(14) = ((initkey%(18) AND &H30) \ 16) OR (initkey%(19) * 4)
k%(15) = initkey%(20) OR ((initkey%(21) AND &H3) * 64)
k%(16) = ((initkey%(21) AND &H3C) \ 4) OR ((initkey%(22) AND &HF) * 16)
k%(17) = ((initkey%(22) AND &H30) \ 16) OR (initkey%(23) * 4)
k%(18) = initkey%(24) OR ((initkey%(25) AND &H3) * 64)
k%(19) = ((initkey%(25) AND &H3C) \ 4) OR ((initkey%(26) AND &HF) * 16)
k%(20) = ((initkey%(26) AND &H30) \ 16) OR (initkey%(27) * 4)
k%(21) = initkey%(28) OR ((initkey%(29) AND &H3) * 64)
k%(22) = ((initkey%(29) AND &H3C) \ 4) OR ((initkey%(30) AND &HF) * 16)
k%(23) = ((initkey%(30) AND &H30) \ 16) OR (initkey%(31) * 4)

END SUB

PRIVATE SUB SWAP (A%, B%)
    Hold% = A%: A% = B%: B% = Hold%
END SUB
